package com.dsic.gj_erp.controller.kban;

import cn.hutool.core.date.DateField;
import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.conditions.query.LambdaQueryChainWrapper;
import com.dsic.gj_erp.bean.ResultBean;
import com.dsic.gj_erp.bean.jhgk.DmYdjh;
import com.dsic.gj_erp.service.jhgk.DmYdjhService;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

@RestController
@RequestMapping("sc")
@AllArgsConstructor
public class SCKbanController {

    private final DmYdjhService service;

    @GetMapping("getYdjhByMonth")
    public ResultBean<?> getYdjhByMonth(){
        DateTime date=DateUtil.date();
        String begin=DateUtil.beginOfMonth(date).toString("yyyy/MM/dd");
        String end=DateUtil.endOfMonth(date).offsetNew(DateField.DAY_OF_YEAR,1).toString("yyyy/MM/dd");
        List<DmYdjh> between = service.list(Wrappers.<DmYdjh>lambdaQuery()
                .select(DmYdjh::getKw,DmYdjh::getQgfkrq,DmYdjh::getZyq1,DmYdjh::getBcshzl,DmYdjh::getQgjhrq)
                        .eq(DmYdjh::getYlbs,"N").and(it->
                                it.between(DmYdjh::getQgfkrq, begin, end).or().between(DmYdjh::getQgjhrq,begin,end)
                        )
        );
        return new ResultBean<>(JSONArray.toJSONString(between));
    }
}
