package com.dsic.gj_erp.controller.txzz.jhgl;

import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.dsic.gj_erp.annotation.Authorization;
import com.dsic.gj_erp.bean.ResultBean;
import com.dsic.gj_erp.bean.txzz.jhgl.TpbhPlan;
import com.dsic.gj_erp.service.txzz.jhgl.TpbhPlanService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletRequest;
import java.io.IOException;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 铁硒托盘相关接口
 */
@Api(tags = "铁硒托盘需求计划相关接口")
@RestController
@RequestMapping("api/tx/tpPlan")
@AllArgsConstructor
public class TpbhPlanController {

    private final TpbhPlanService tpbhService;

    @PostMapping("list")
    @ApiOperation("托盘需求计划查询")
    public ResultBean<?> list(@RequestBody TpbhPlan tpbhPlan){
        QueryWrapper<TpbhPlan> wrapper=new QueryWrapper<>(tpbhPlan);
        List<TpbhPlan> list=tpbhService.list(wrapper);
        return new ResultBean<>(list);
    }

    @PostMapping("excel")
    @ApiOperation("托盘需求计划excel导入")
    public ResultBean<?> excel(MultipartFile file) throws IOException {
        return new ResultBean<>();
    }

    @ApiOperation("托盘需求计划保存")
    @PostMapping("save")
    public ResultBean<?> save(@RequestBody List<TpbhPlan> list){
        list.forEach(l->{

        });
        list=list.stream().filter(TpbhPlan::canSave).collect(Collectors.toList());
        tpbhService.saveOrUpdateBatch(list);
        return new ResultBean<>();
    }

    @ApiOperation("托盘需求计划提交")
    @PostMapping("submit")
    @Authorization
    public ResultBean<?> submit(@RequestBody List<TpbhPlan> list, HttpServletRequest request){
        String userName=(String) request.getAttribute("username");
        String userCode=(String) request.getAttribute("yhdm");
        if (StrUtil.isEmpty(userName)||StrUtil.isEmpty(userCode)){
            throw new RuntimeException("登录信息错误,请刷新后重新登录");
        }
        this.tpbhService.submitHandler(list,userName,userCode);
        return new ResultBean<>();
    }

    /**
     * 提取
     */
    @GetMapping("extract")
    public ResultBean<?> extract(String project,String dwgNo){
        if (StrUtil.isEmpty(project)){
            throw new RuntimeException("请选择工程编号");
        }

        return new ResultBean<>();
    }

    /**
     * 审核
     */
    @PostMapping("sh")
    @Authorization
    public ResultBean<?> sh(@RequestBody List<TpbhPlan> list,HttpServletRequest request){
        String userName=(String) request.getAttribute("username");
        String userCode=(String) request.getAttribute("yhdm");
        if (StrUtil.isEmpty(userName)||StrUtil.isEmpty(userCode)){
            throw new RuntimeException("登录信息错误,请刷新后重新登录");
        }
        if (list.size()==0){
            throw new RuntimeException("请选择审核的数据");
        }
        this.tpbhService.examine(list,userName,userCode,"sh");
        return new ResultBean<>();
    }

    /**
     * 审批
     */
    @PostMapping("sp")
    @Authorization
    public ResultBean<?> sp(@RequestBody List<TpbhPlan> list,HttpServletRequest request){
        String userName=(String) request.getAttribute("username");
        String userCode=(String) request.getAttribute("yhdm");
        if (StrUtil.isEmpty(userName)||StrUtil.isEmpty(userCode)){
            throw new RuntimeException("登录信息错误,请刷新后重新登录");
        }
        if (list.size()==0){
            throw new RuntimeException("请选择审核的数据");
        }
        this.tpbhService.examine(list,userName,userCode,"sp");
        return new ResultBean<>();
    }
}
